 <?php
defined('IMAGEMAGICKGPS_PATH')or die('Hacking attempt!');

// +-----------------------------------------------------------------------+
// | Read Exif Data tab                                                    |
// +-----------------------------------------------------------------------+

// Check access and exit when user status is not ok
check_status(ACCESS_ADMINISTRATOR); 

if (isset($_GET['showexifdata'])and!isset($_POST['submitreadexifdata']))
{
	check_input_parameter('showexifdata', $_GET, false, PATTERN_ID);
	$_POST['idreadexifdata'] = $_GET['showexifdata'];
	$_POST['submitreadexifdata'] = 1;
}

if (isset($_POST['idreadexifdata2'])and $_POST['idreadexifdata2'] != -1)
{
	$_POST['idreadexifdata'] = $_POST['idreadexifdata2'];
}

if (isset($_POST['idreadexifdata']))
{
	$template->assign(
		'read',
		array('RM_ID' => $_POST['idreadexifdata']));
}
else
{
	$template->assign(
		'read',
		array('RM_ID' => ''));
}

$tab_picture = pwg_query('SELECT id,name FROM '.IMAGES_TABLE.' order by id;');
if (pwg_db_num_rows($tab_picture))
{
	while ($info_photos = pwg_db_fetch_assoc($tab_picture))
	{
		$items = array(
				'PHOTOID' => $info_photos['id'],
				'PHOTOINFO' => $info_photos['id'].' - '.$info_photos['name'], );
		$template->append('info_photos', $items);
	}
}
if (isset($_POST['submitreadexifdata']))
{
	if (isset($_POST['idreadexifdata'])and is_numeric($_POST['idreadexifdata']))
	{
		$query = 'select id,name,file,path FROM '.IMAGES_TABLE.' WHERE id = \''.$_POST['idreadexifdata'].'\';';
		$result = pwg_query($query);
		$row = pwg_db_fetch_assoc($result);
		$filename = $row['path'];
		if (empty($filename))
		{
			$_SESSION['page_infos'] = array(l10n('This ID isn\'t used in your gallery'));
			redirect($admin_base_url);
		}
		if (exif_imagetype($filename) != IMAGETYPE_JPEG and exif_imagetype($filename) != IMAGETYPE_TIFF_II and exif_imagetype($filename) != IMAGETYPE_TIFF_MM)
		{
			$_SESSION['page_infos'] = array(l10n('This file type doesn\'t use exifdata'));
			redirect($admin_base_url);
		}
		$rd_image = new SrcImage($row);
		$name = $row['name'];
		$file = $row['file'];
		$template->assign(
			'readexifdata',
			array(
				'RM_NAME' => $name,
				'RM_FILE' => $file,
				'RM_SCR' => DerivativeImage::url(IMG_THUMB, $rd_image),
				'U_SHOWPHOTOADMIN' => 'admin.php?page=photo-'.$_POST['idreadexifdata'], ));

		/*Exif*/
		ob_start(); // print output (warnings) to a buffer
		$exif = read_exif_data($filename);
		$read_exif_data_warnings = ob_get_contents();
		ob_end_clean();

		if (!empty($read_exif_data_warnings))
		{
			$template->assign('readexifdata2', array('RM_WARNINGWORDING' => 'Warnings from PHP function read_exif_data('.$file.')', 'RM_WARNING' => $read_exif_data_warnings, ));
		}
		
		$map = array();
		$exif = trigger_change('format_exif_data', $exif, $filename, $map);
		
		//var_dump($exif);
		
		foreach($exif as $key => $section)
		{
			if (is_array($section))
			{
				$i = 0;
				foreach($section as $name => $value)
				{
					if ($i == 0)
					{
						$items['RM_SECTION'] = $key.'<br>';
					}
					else
					{
						$items['RM_SECTION'] = '';
					}
					$items['RM_KEY'] = $name;
					$items['RM_VALUE'] = $value;
					$template->append('rm_exif', $items);
					$i++;
				}
			}
			else
			{
				$items['RM_SECTION'] = '1';
				$items['RM_KEY'] = $key;
				$items['RM_VALUE'] = $section;
				$template->append('rm_exif', $items);
			}
		}
		$template->assign(
			'readexifdata3',
			array(
				'RM_EXIFWORDING' => 'EXIF Fields in ', ));

	}
	else
	{
		$_SESSION['page_infos'] = array(l10n('You must choose a photo ID'));
		redirect($admin_base_url);
	}
}

// define template file
$template->set_filename('imagemagick_gps_content', realpath(IMAGEMAGICKGPS_PATH.'admin/template/read.tpl'));